/*	For every article that mentioned symbols, record the date.  Delete articles without date.	
	The final results are stored in SAS data set 'articles_date_orig' and tab-delimited text file 'articles_date_orig.txt'.	*/

data articles;
	infile 'D:\research\Collaboration with Wolfgang Haerdle\output\articles.txt' delimiter='09'x MISSOVER DSD lrecl=32767;
	informat author $100.;
	informat linkfile best32.;
	informat link best32.;
	format author $100.;
	format linkfile best32.;
	format link best32.;
	input author linkfile link;
run;

data allarticles_date_orig;
	infile 'D:\research\Collaboration with Wolfgang Haerdle\output\allarticles_date_orig.txt' delimiter='09'x MISSOVER DSD lrecl=32767;
	informat author $100.;
	informat linkfile best32.;
	informat link best32.;
	informat dateorig $10.;
	format author $100.;
	format linkfile best32.;
	format link best32.;
	format dateorig $10.;
	input author linkfile link dateorig;
run;


data allarticles_date;
	set allarticles_date_orig;
	month=scan(dateorig,1,"/");
	day=scan(dateorig,2,"/");
	year=scan(dateorig,3,"/");
	if month^='NA';
	date=mdy(month,day,year);
	format date mmddyy10.;
	drop dateorig month day year;
run;

proc sort data=articles;
	by author linkfile link;
run;

proc sort data=allarticles_date;
	by author linkfile link;
run;

proc sql noprint;
	create table articles_date as
	select * from allarticles_date 
	where cats(author,linkfile,link) in (select cats(author,linkfile,link) from articles);
quit;

data output.articles_date_orig;
	retain order author linkfile link date;
	set articles_date;
	retain order 0;
	order=order+1;
run;

/***	Export the SAS data set 'articles_date_orig' into a tab-delimited '.txt' file.	***/

