/*	Bing Liu's lexicon	*/
data BLwords1;
	%let _EFIERR_ = 0; /* set the ERROR detection macro variable */
	infile "D:\research\Collaboration with Wolfgang Haerdle\output\articles_sentiment_BL_negdis5.txt" delimiter= '09'x MISSOVER DSD lrecl=32767 firstobs=1;
	informat order best32.;
	informat word $50.;
	informat sent $10.;
	informat count best32.;
	format order best32.;
	format word $50.;
	format sent $10.;
	format count best32.;
	input order word sent count;
run;

data BLwords1;
	set BLwords1;
	if _n_<1292834; /*	order<=67825	*/
run;

data BLwords2;	/*	starting from order=67826	*/
	%let _EFIERR_ = 0; /* set the ERROR detection macro variable */
	infile "D:\research\Collaboration with Wolfgang Haerdle\output\articles_sentiment_BL2_negdis5.txt" delimiter= '09'x MISSOVER DSD lrecl=32767 firstobs=1;
	informat order best32.;
	informat word $50.;
	informat sent $10.;
	informat count best32.;
	format order best32.;
	format word $50.;
	format sent $10.;
	format count best32.;
	input order word sent count;
run;

data BLwords;
	set BLwords1 BLwords2;
run;

/*	LM lexicon	*/
data LMwords;
	%let _EFIERR_ = 0; /* set the ERROR detection macro variable */
	infile "D:\research\Collaboration with Wolfgang Haerdle\output\articles_sentiment_LM_negdis5.txt" delimiter= '09'x MISSOVER DSD lrecl=32767 firstobs=1;
	informat order best32.;
	informat word $50.;
	informat sent $10.;
	informat count best32.;
	format order best32.;
	format word $50.;
	format sent $10.;
	format count best32.;
	input order word sent count;
run;

data LMwords;
	set LMwords;
	if sent="Positive" or sent="Negative";
	if sent="Positive" then sent="positive";
	if sent="Negative" then sent="negative";
run;

/*	MPQA lexicon	*/
data MPQAwords1;
	%let _EFIERR_ = 0; /* set the ERROR detection macro variable */
	infile "D:\research\Collaboration with Wolfgang Haerdle\output\articles_sentiment_MPQA_negdis5.txt" delimiter= '09'x MISSOVER DSD lrecl=32767 firstobs=1;
	informat order best32.;
	informat word $50.;
	informat pos $10.;
	informat stemmed $10.;
	informat degree $10.;
	informat sent $10.;
	informat count best32.;
	format order best32.;
	format word $50.;
	format pos $10.;
	format stemmed $10.;
	format degree $10.;
	format sent $10.;
	format count best32.;
	input order word pos stemmed degree sent count;
run;

data MPQAwords1;
	set MPQAwords1;
	if _n_<2106857; /*	order<=67825	*/
run;

/*	MPQA lexicon	*/
data MPQAwords2;
	%let _EFIERR_ = 0; /* set the ERROR detection macro variable */
	infile "D:\research\Collaboration with Wolfgang Haerdle\output\articles_sentiment_MPQA2_negdis5.txt" delimiter= '09'x MISSOVER DSD lrecl=32767 firstobs=1;
	informat order best32.;
	informat word $50.;
	informat pos $10.;
	informat stemmed $10.;
	informat degree $10.;
	informat sent $10.;
	informat count best32.;
	format order best32.;
	format word $50.;
	format pos $10.;
	format stemmed $10.;
	format degree $10.;
	format sent $10.;
	format count best32.;
	input order word pos stemmed degree sent count;
run;

data MPQAwords;
	set MPQAwords1 MPQAwords2;
	if sent="positive" or sent="negative";
run;



/**************	Sentiment words for relevant articles.	************************/
proc sql noprint;
	create table relBLwords as
	select * from BLwords
	where order in (select order from output.Relevant_articles);
quit;

proc sql noprint;
	create table relLMwords as
	select * from LMwords
	where order in (select order from output.Relevant_articles);
quit;

proc sql noprint;
	create table relMPQAwords as
	select * from MPQAwords
	where order in (select order from output.Relevant_articles);
quit;

data relBLwords;
	set relBLwords;
	length wordsent $50.;
	wordsent=cats(word,"||",sent);
run;

data relLMwords;
	set relLMwords;
	length wordsent $50.;
	wordsent=cats(word,"||",sent);
run;

data relMPQAwords;
	set relMPQAwords;
	length wordsent $100.;
	wordsent=cats(word,"||",sent);
	wordsent2=cats(word,"||",pos,"||",stemmed,"||",sent);
run;

/*	Merge with date and article length.	*/
proc sort data=relBLwords;
	by order;
run;
proc sort data=relLMwords;
	by order;
run;
proc sort data=relMPQAwords;
	by order;
run;
proc sort data=output.Relevant_articles;
	by order;
run;
data Sym_arti_sent_negdis5;
	set output.Sym_arti_sent_negdis5;
run;
proc sort data=Sym_arti_sent_negdis5 nodupkey;
	by order;
run;
data relBLwords;
	merge relBLwords (in=data1) output.Relevant_articles (keep=order date) Sym_arti_sent_negdis5 (keep=order length);
	by order;
	if data1;
run;
data relLMwords;
	merge relLMwords (in=data1) output.Relevant_articles (keep=order date) Sym_arti_sent_negdis5 (keep=order length);
	by order;
	if data1;
run;
data relMPQAwords;
	merge relMPQAwords (in=data1) output.Relevant_articles (keep=order date) Sym_arti_sent_negdis5 (keep=order length);
	by order;
	if data1;
run;

PROC EXPORT DATA=relBLwords    
	OUTFILE= "&outpath.\relBLwords.csv"    
	DBMS=dlm REPLACE;    
	DELIMITER=',';
RUN;
PROC EXPORT DATA=relLMwords    
	OUTFILE= "&outpath.\relLMwords.csv"    
	DBMS=dlm REPLACE;    
	DELIMITER=',';
RUN;	
PROC EXPORT DATA=relMPQAwords    
	OUTFILE= "&outpath.\relMPQAwords.csv"    
	DBMS=dlm REPLACE;    
	DELIMITER=',';
RUN;


data relBLwords;
	set relBLwords;
	prop=count/length;
run;
data relLMwords;
	set relLMwords;
	prop=count/length;
run;
data relMPQAwords;
	set relMPQAwords;
	prop=count/length;
run;


/**************	Comparison of sentiment words for the three lexica.	************************/
/*****	over all articles, over all days	*****/
proc sql noprint;
	select count(*) into :nallart from output.Relevant_articles;
quit;

proc freq data=relBLwords noprint;
	table wordsent /out=BL_sumcount;
	weight count;
run;

proc freq data=relLMwords noprint;
	table wordsent /out=LM_sumcount;
	weight count;
run;

proc freq data=relMPQAwords noprint;
	table wordsent /out=MPQA_sumcount;
	weight count;
run;

proc sort data=BL_sumcount;
	by descending count;
run;

proc sort data=LM_sumcount;
	by descending count;
run;

proc sort data=MPQA_sumcount;
	by descending count;
run;

/*	In BL, in LM, in MPQA.	*/
proc sql noprint;
	create table word_BL_LM_MPQA as
	select wordsent, count
	from BL_sumcount 
	where wordsent in (select wordsent from LM_sumcount)
	and wordsent in (select wordsent from MPQA_sumcount);
quit;

data word_BL_LM_MPQA;
	set word_BL_LM_MPQA;
	word=scan(wordsent,1,"||");
	sent=scan(wordsent,2,"||");
run;

/*	In BL, not in LM, not in MPQA.	*/
proc sql noprint;
	create table word_BL_nLM_nMPQA as
	select wordsent, count
	from BL_sumcount 
	where wordsent not in (select wordsent from LM_sumcount)
	and wordsent not in (select wordsent from MPQA_sumcount);
quit;

data word_BL_nLM_nMPQA;
	set word_BL_nLM_nMPQA;
	word=scan(wordsent,1,"||");
	sent=scan(wordsent,2,"||");
run;

/*	Not in BL, in LM, not in MPQA.	*/
proc sql noprint;
	create table word_nBL_LM_nMPQA as
	select wordsent, count
	from LM_sumcount 
	where wordsent not in (select wordsent from BL_sumcount)
	and wordsent not in (select wordsent from MPQA_sumcount);
quit;

data word_nBL_LM_nMPQA;
	set word_nBL_LM_nMPQA;
	word=scan(wordsent,1,"||");
	sent=scan(wordsent,2,"||");
run;

/*	Not in BL, not in LM, in MPQA.	*/
proc sql noprint;
	create table word_nBL_nLM_MPQA as
	select wordsent, count
	from MPQA_sumcount 
	where wordsent not in (select wordsent from BL_sumcount)
	and wordsent not in (select wordsent from LM_sumcount);
quit;

data word_nBL_nLM_MPQA;
	set word_nBL_nLM_MPQA;
	word=scan(wordsent,1,"||");
	sent=scan(wordsent,2,"||");
run;

/*	In BL, in LM, not in MPQA.	*/
proc sql noprint;
	create table word_BL_LM_nMPQA as
	select wordsent, count
	from BL_sumcount 
	where wordsent in (select wordsent from LM_sumcount)
	and wordsent not in (select wordsent from MPQA_sumcount);
quit;

data word_BL_LM_nMPQA;
	set word_BL_LM_nMPQA;
	word=scan(wordsent,1,"||");
	sent=scan(wordsent,2,"||");
run;

/*	In BL, not in LM, in MPQA.	*/
proc sql noprint;
	create table word_BL_nLM_MPQA as
	select wordsent, count
	from BL_sumcount 
	where wordsent not in (select wordsent from LM_sumcount)
	and wordsent in (select wordsent from MPQA_sumcount);
quit;

data word_BL_nLM_MPQA;
	set word_BL_nLM_MPQA;
	word=scan(wordsent,1,"||");
	sent=scan(wordsent,2,"||");
run;

/*	Not in BL, in LM, in MPQA.	*/
proc sql noprint;
	create table word_nBL_LM_MPQA as
	select wordsent, count
	from LM_sumcount 
	where wordsent not in (select wordsent from BL_sumcount)
	and wordsent in (select wordsent from MPQA_sumcount);
quit;

data word_nBL_LM_MPQA;
	set word_nBL_LM_MPQA;
	word=scan(wordsent,1,"||");
	sent=scan(wordsent,2,"||");
run;



proc sql noprint;
	select sum(count) into :sumpos_BL_LM_MPQA from word_BL_LM_MPQA
	where sent="positive";
quit;
proc sql noprint;
	select sum(count) into :sumneg_BL_LM_MPQA from word_BL_LM_MPQA
	where sent="negative";
quit;
proc sql noprint;
	select sum(count) into :sumpos_BL_nLM_nMPQA from word_BL_nLM_nMPQA
	where sent="positive";
quit;
proc sql noprint;
	select sum(count) into :sumneg_BL_nLM_nMPQA from word_BL_nLM_nMPQA
	where sent="negative";
quit;
proc sql noprint;
	select sum(count) into :sumpos_nBL_LM_nMPQA from word_nBL_LM_nMPQA
	where sent="positive";
quit;
proc sql noprint;
	select sum(count) into :sumneg_nBL_LM_nMPQA from word_nBL_LM_nMPQA
	where sent="negative";
quit;
proc sql noprint;
	select sum(count) into :sumpos_nBL_nLM_MPQA from word_nBL_nLM_MPQA
	where sent="positive";
quit;
proc sql noprint;
	select sum(count) into :sumneg_nBL_nLM_MPQA from word_nBL_nLM_MPQA
	where sent="negative";
quit;
proc sql noprint;
	select sum(count) into :sumpos_BL_LM_nMPQA from word_BL_LM_nMPQA
	where sent="positive";
quit;
proc sql noprint;
	select sum(count) into :sumneg_BL_LM_nMPQA from word_BL_LM_nMPQA
	where sent="negative";
quit;
proc sql noprint;
	select sum(count) into :sumpos_BL_nLM_MPQA from word_BL_nLM_MPQA
	where sent="positive";
quit;
proc sql noprint;
	select sum(count) into :sumneg_BL_nLM_MPQA from word_BL_nLM_MPQA
	where sent="negative";
quit;
proc sql noprint;
	select sum(count) into :sumpos_nBL_LM_MPQA from word_nBL_LM_MPQA
	where sent="positive";
quit;
proc sql noprint;
	select sum(count) into :sumneg_nBL_LM_MPQA from word_nBL_LM_MPQA
	where sent="negative";
quit;

data sumcounts;
	BL=1;
	LM=1;
	MPQA=1;
	sumpos=&sumpos_BL_LM_MPQA.;
	sumneg=&sumneg_BL_LM_MPQA.;
	output;
	BL=1;
	LM=0;
	MPQA=0;
	sumpos=&sumpos_BL_nLM_nMPQA.;
	sumneg=&sumneg_BL_nLM_nMPQA.;
	output;
	BL=0;
	LM=1;
	MPQA=0;
	sumpos=&sumpos_nBL_LM_nMPQA.;
	sumneg=&sumneg_nBL_LM_nMPQA.;
	output;
	BL=0;
	LM=0;
	MPQA=1;
	sumpos=&sumpos_nBL_nLM_MPQA.;
	sumneg=&sumneg_nBL_nLM_MPQA.;
	output;
	BL=1;
	LM=1;
	MPQA=0;
	sumpos=&sumpos_BL_LM_nMPQA.;
	sumneg=&sumneg_BL_LM_nMPQA.;
	output;
	BL=1;
	LM=0;
	MPQA=1;
	sumpos=&sumpos_BL_nLM_MPQA.;
	sumneg=&sumneg_BL_nLM_MPQA.;
	output;
	BL=0;
	LM=1;
	MPQA=1;
	sumpos=&sumpos_nBL_LM_MPQA.;
	sumneg=&sumneg_nBL_LM_MPQA.;
	output;
run;


/*	Words unique to BL, LM or MPQA.	*/
proc sql noprint;
	select count(*) into :pos_BL_nLM_nMPQA from word_BL_nLM_nMPQA
	where count>=3 and sent="positive";
quit;
proc sql noprint;
	select count(*) into :neg_BL_nLM_nMPQA from word_BL_nLM_nMPQA
	where count>=3 and sent="negative";
quit;
proc sql noprint;
	select count(*) into :pos_nBL_LM_nMPQA from word_nBL_LM_nMPQA
	where count>=3 and sent="positive";
quit;
proc sql noprint;
	select count(*) into :neg_nBL_LM_nMPQA from word_nBL_LM_nMPQA
	where count>=3 and sent="negative";
quit;
proc sql noprint;
	select count(*) into :pos_nBL_nLM_MPQA from word_nBL_nLM_MPQA
	where count>=3 and sent="positive";
quit;
proc sql noprint;
	select count(*) into :neg_nBL_nLM_MPQA from word_nBL_nLM_MPQA
	where count>=3 and sent="negative";
quit;


%put &pos_BL_nLM_nMPQA. &neg_BL_nLM_nMPQA. &pos_nBL_LM_nMPQA. &neg_nBL_LM_nMPQA. &pos_nBL_nLM_MPQA. &neg_nBL_nLM_MPQA.;


/*	Words shared only by BL and LM, BL and MPQA, or LM and MPQA.	*/
proc sql noprint;
	select count(*) into :pos_BL_LM_nMPQA from word_BL_LM_nMPQA
	where count>=3 and sent="positive";
quit;
proc sql noprint;
	select count(*) into :neg_BL_LM_nMPQA from word_BL_LM_nMPQA
	where count>=3 and sent="negative";
quit;
proc sql noprint;
	select count(*) into :pos_BL_nLM_MPQA from word_BL_nLM_MPQA
	where count>=3 and sent="positive";
quit;
proc sql noprint;
	select count(*) into :neg_BL_nLM_MPQA from word_BL_nLM_MPQA
	where count>=3 and sent="negative";
quit;
proc sql noprint;
	select count(*) into :pos_nBL_LM_MPQA from word_nBL_LM_MPQA
	where count>=3 and sent="positive";
quit;
proc sql noprint;
	select count(*) into :neg_nBL_LM_MPQA from word_nBL_LM_MPQA
	where count>=3 and sent="negative";
quit;


%put &pos_BL_LM_nMPQA. &neg_BL_LM_nMPQA. &pos_BL_nLM_MPQA. &neg_BL_nLM_MPQA. &pos_nBL_LM_MPQA. &neg_nBL_LM_MPQA.;

data tenpos_BL_LM_nMPQA;
	set word_BL_LM_nMPQA;
	if sent="positive";
run;
data tenpos_BL_LM_nMPQA;
	set tenpos_BL_LM_nMPQA;
	if _n_<=10;
run;

data tenneg_BL_LM_nMPQA;
	set word_BL_LM_nMPQA;
	if sent="negative";
run;
data tenneg_BL_LM_nMPQA;
	set tenneg_BL_LM_nMPQA;
	if _n_<=10;
run;

data tenpos_BL_nLM_MPQA;
	set word_BL_nLM_MPQA;
	if sent="positive";
run;
data tenpos_BL_nLM_MPQA;
	set tenpos_BL_nLM_MPQA;
	if _n_<=10;
run;

data tenneg_BL_nLM_MPQA;
	set word_BL_nLM_MPQA;
	if sent="negative";
run;
data tenneg_BL_nLM_MPQA;
	set tenneg_BL_nLM_MPQA;
	if _n_<=10;
run;

data tenpos_nBL_LM_MPQA;
	set word_nBL_LM_MPQA;
	if sent="positive";
run;
data tenpos_nBL_LM_MPQA;
	set tenpos_nBL_LM_MPQA;
	if _n_<=10;
run;

data tenneg_nBL_LM_MPQA;
	set word_nBL_LM_MPQA;
	if sent="negative";
run;
data tenneg_nBL_LM_MPQA;
	set tenneg_nBL_LM_MPQA;
	if _n_<=10;
run;



/*****	over all articles, over all days	*****/
proc sql noprint;
	select count(*) into :nallart from output.Relevant_articles;
quit;

proc freq data=relBLwords noprint;
	table wordsent /out=BL_sumprop;
	weight prop;
run;

proc freq data=relLMwords noprint;
	table wordsent /out=LM_sumprop;
	weight prop;
run;

proc freq data=relMPQAwords noprint;
	table wordsent /out=MPQA_sumprop;
	weight prop;
run;

proc sort data=BL_sumprop;
	by descending count;
run;

proc sort data=LM_sumprop;
	by descending count;
run;

proc sort data=MPQA_sumprop;
	by descending count;
run;

/*	In BL, in LM, in MPQA.	*/
proc sql noprint;
	create table word_BL_LM_MPQA as
	select wordsent, count
	from BL_sumprop 
	where wordsent in (select wordsent from LM_sumprop)
	and wordsent in (select wordsent from MPQA_sumprop);
quit;

data word_BL_LM_MPQA;
	set word_BL_LM_MPQA;
	word=scan(wordsent,1,"||");
	sent=scan(wordsent,2,"||");
run;

/*	In BL, not in LM, not in MPQA.	*/
proc sql noprint;
	create table word_BL_nLM_nMPQA as
	select wordsent, count
	from BL_sumprop 
	where wordsent not in (select wordsent from LM_sumprop)
	and wordsent not in (select wordsent from MPQA_sumprop);
quit;

data word_BL_nLM_nMPQA;
	set word_BL_nLM_nMPQA;
	word=scan(wordsent,1,"||");
	sent=scan(wordsent,2,"||");
run;

/*	Not in BL, in LM, not in MPQA.	*/
proc sql noprint;
	create table word_nBL_LM_nMPQA as
	select wordsent, count
	from LM_sumprop 
	where wordsent not in (select wordsent from BL_sumprop)
	and wordsent not in (select wordsent from MPQA_sumprop);
quit;

data word_nBL_LM_nMPQA;
	set word_nBL_LM_nMPQA;
	word=scan(wordsent,1,"||");
	sent=scan(wordsent,2,"||");
run;

/*	Not in BL, not in LM, in MPQA.	*/
proc sql noprint;
	create table word_nBL_nLM_MPQA as
	select wordsent, count
	from MPQA_sumprop 
	where wordsent not in (select wordsent from BL_sumprop)
	and wordsent not in (select wordsent from LM_sumprop);
quit;

data word_nBL_nLM_MPQA;
	set word_nBL_nLM_MPQA;
	word=scan(wordsent,1,"||");
	sent=scan(wordsent,2,"||");
run;

/*	In BL, in LM, not in MPQA.	*/
proc sql noprint;
	create table word_BL_LM_nMPQA as
	select wordsent, count
	from BL_sumprop 
	where wordsent in (select wordsent from LM_sumprop)
	and wordsent not in (select wordsent from MPQA_sumprop);
quit;

data word_BL_LM_nMPQA;
	set word_BL_LM_nMPQA;
	word=scan(wordsent,1,"||");
	sent=scan(wordsent,2,"||");
run;

/*	In BL, not in LM, in MPQA.	*/
proc sql noprint;
	create table word_BL_nLM_MPQA as
	select wordsent, count
	from BL_sumprop 
	where wordsent not in (select wordsent from LM_sumprop)
	and wordsent in (select wordsent from MPQA_sumprop);
quit;

data word_BL_nLM_MPQA;
	set word_BL_nLM_MPQA;
	word=scan(wordsent,1,"||");
	sent=scan(wordsent,2,"||");
run;

/*	Not in BL, in LM, in MPQA.	*/
proc sql noprint;
	create table word_nBL_LM_MPQA as
	select wordsent, count
	from LM_sumprop 
	where wordsent not in (select wordsent from BL_sumprop)
	and wordsent in (select wordsent from MPQA_sumprop);
quit;

data word_nBL_LM_MPQA;
	set word_nBL_LM_MPQA;
	word=scan(wordsent,1,"||");
	sent=scan(wordsent,2,"||");
run;



proc sql noprint;
	select sum(count) into :sumpos_BL_LM_MPQA from word_BL_LM_MPQA
	where sent="positive";
quit;
proc sql noprint;
	select sum(count) into :sumneg_BL_LM_MPQA from word_BL_LM_MPQA
	where sent="negative";
quit;
proc sql noprint;
	select sum(count) into :sumpos_BL_nLM_nMPQA from word_BL_nLM_nMPQA
	where sent="positive";
quit;
proc sql noprint;
	select sum(count) into :sumneg_BL_nLM_nMPQA from word_BL_nLM_nMPQA
	where sent="negative";
quit;
proc sql noprint;
	select sum(count) into :sumpos_nBL_LM_nMPQA from word_nBL_LM_nMPQA
	where sent="positive";
quit;
proc sql noprint;
	select sum(count) into :sumneg_nBL_LM_nMPQA from word_nBL_LM_nMPQA
	where sent="negative";
quit;
proc sql noprint;
	select sum(count) into :sumpos_nBL_nLM_MPQA from word_nBL_nLM_MPQA
	where sent="positive";
quit;
proc sql noprint;
	select sum(count) into :sumneg_nBL_nLM_MPQA from word_nBL_nLM_MPQA
	where sent="negative";
quit;
proc sql noprint;
	select sum(count) into :sumpos_BL_LM_nMPQA from word_BL_LM_nMPQA
	where sent="positive";
quit;
proc sql noprint;
	select sum(count) into :sumneg_BL_LM_nMPQA from word_BL_LM_nMPQA
	where sent="negative";
quit;
proc sql noprint;
	select sum(count) into :sumpos_BL_nLM_MPQA from word_BL_nLM_MPQA
	where sent="positive";
quit;
proc sql noprint;
	select sum(count) into :sumneg_BL_nLM_MPQA from word_BL_nLM_MPQA
	where sent="negative";
quit;
proc sql noprint;
	select sum(count) into :sumpos_nBL_LM_MPQA from word_nBL_LM_MPQA
	where sent="positive";
quit;
proc sql noprint;
	select sum(count) into :sumneg_nBL_LM_MPQA from word_nBL_LM_MPQA
	where sent="negative";
quit;

data sumprops;
	BL=1;
	LM=1;
	MPQA=1;
	sumpos=&sumpos_BL_LM_MPQA.;
	sumneg=&sumneg_BL_LM_MPQA.;
	output;
	BL=1;
	LM=0;
	MPQA=0;
	sumpos=&sumpos_BL_nLM_nMPQA.;
	sumneg=&sumneg_BL_nLM_nMPQA.;
	output;
	BL=0;
	LM=1;
	MPQA=0;
	sumpos=&sumpos_nBL_LM_nMPQA.;
	sumneg=&sumneg_nBL_LM_nMPQA.;
	output;
	BL=0;
	LM=0;
	MPQA=1;
	sumpos=&sumpos_nBL_nLM_MPQA.;
	sumneg=&sumneg_nBL_nLM_MPQA.;
	output;
	BL=1;
	LM=1;
	MPQA=0;
	sumpos=&sumpos_BL_LM_nMPQA.;
	sumneg=&sumneg_BL_LM_nMPQA.;
	output;
	BL=1;
	LM=0;
	MPQA=1;
	sumpos=&sumpos_BL_nLM_MPQA.;
	sumneg=&sumneg_BL_nLM_MPQA.;
	output;
	BL=0;
	LM=1;
	MPQA=1;
	sumpos=&sumpos_nBL_LM_MPQA.;
	sumneg=&sumneg_nBL_LM_MPQA.;
	output;
run;

