/*	Replace DSCD variable names with symbols in S&P 500 dataset "dataname",
	where the correspondence between DSCDs and symbols is given by the dataset "DSCDSymbol". */
%macro ReplaceDSCDwithSymbol(dataname,DSCDSymbol);
	proc sql noprint;
		select DSCD into :DSCDs separated by ' ' from mydata.&dataname._DS;
		select symbol into :symbols separated by ' ' from mydata.&dataname._DS;
	quit;

	data mydata.&dataname._new;
		set mydata.&dataname.;
		%let i=1;
		%do %until (%scan(&DSCDs.,&i,' ')=);
			%let DSCD=%scan(&DSCDs.,&i,' ');
			%let symbol=%scan(&symbols,&i,' ');
			rename X&DSCD.=&symbol.;
			%let i=%eval(&i.+1);
		%end;
	run;

	data mydata.&dataname._new;
		set mydata.&dataname._new;
		keep date &symbols.;
	run;
%mend;

%ReplaceDSCDwithSymbol(High);
%ReplaceDSCDwithSymbol(Low);
%ReplaceDSCDwithSymbol(Open);
%ReplaceDSCDwithSymbol(Price);
%ReplaceDSCDwithSymbol(H_gk);
%ReplaceDSCDwithSymbol(Log_Returns);
%ReplaceDSCDwithSymbol(Volume);
%ReplaceDSCDwithSymbol(Log_Volume);
%ReplaceDSCDwithSymbol(Log_Volume_Linear_Trend);
%ReplaceDSCDwithSymbol(Log_Volume_Linear_Residual);
%ReplaceDSCDwithSymbol(Log_Volume_Expected);
%ReplaceDSCDwithSymbol(Log_Volume_Unexpected);
