/*	GICS_sector for each symbol.	*/
data mydata.sector    ;
	%let _EFIERR_ = 0; /* set the ERROR detection macro variable */
	infile 'D:\research\Collaboration with Wolfgang Haerdle\20141113 SP500 Datastream Data\Constituents_October_2014.csv' delimiter = ';' MISSOVER DSD lrecl=32767 firstobs=2 ;
	informat symbol $20. ;
	informat name $100. ;
	informat GICS_sector $100. ;
	informat GICS_industry_group $100. ;
	informat GICS_industry $100. ;
	informat GICS_industry_sub $100. ;
	format symbol $20. ;
	format name $100. ;
	format GICS_sector $100. ;
	format GICS_industry_group $100. ;
	format GICS_industry $100. ;
	format GICS_industry_sub $100. ;
	input	symbol $
			name $
			GICS_sector $
			GICS_industry_group $
			GICS_industry $
			GICS_industry_sub $;
	if _ERROR_ then call symputx('_EFIERR_',1);  /* set ERROR detection macro variable */
	symbol=lowcase(symbol);
	keep symbol GICS_sector;
run;

/*	debt ratio for each symbol and each year of 2009-2013.	
	Need to remove NAs and replace ',' with '.' in the .csv file.	*/
data mydata.debtratio;
	%let _EFIERR_ = 0; /* set the ERROR detection macro variable */
	infile 'D:\research\Collaboration with Wolfgang Haerdle\20141113 SP500 Datastream Data\debt_ratio.csv' delimiter = ';' MISSOVER DSD lrecl=32767 firstobs=2 ;
	informat name $100. ;
	informat symbol $20. ;
	informat debt_ratio_07 best32. ;
	informat debt_ratio_08 best32. ;
	informat debt_ratio_09 best32. ;
	informat debt_ratio_10 best32.;
	informat debt_ratio_11 best32. ;
	informat debt_ratio_12 best32. ;
	informat debt_ratio_13 best32. ;
	format name $100. ;
	format symbol $20. ;
	format debt_ratio_07 best32. ;
	format debt_ratio_08 best32. ;
	format debt_ratio_09 best32. ;
	format debt_ratio_10 best32.;
	format debt_ratio_11 best32. ;
	format debt_ratio_12 best32. ;
	format debt_ratio_13 best32. ;
	input	name $
			symbol $
			debt_ratio_07
			debt_ratio_08
			debt_ratio_09
			debt_ratio_10
			debt_ratio_11
			debt_ratio_12
			debt_ratio_13;
	if _ERROR_ then call symputx('_EFIERR_',1);  /* set ERROR detection macro variable */
	symbol=lowcase(symbol);
	drop name;
	keep symbol debt_ratio_08 debt_ratio_09 debt_ratio_10 debt_ratio_11 debt_ratio_12 debt_ratio_13;
run;

data debtratio_08;
	set mydata.debtratio;
	year=2008;
	keep symbol year debt_ratio_08;
	rename debt_ratio_08=debtratio;
run;

data debtratio_09;
	set mydata.debtratio;
	year=2009;
	keep symbol year debt_ratio_09;
	rename debt_ratio_09=debtratio;
run;

data debtratio_10;
	set mydata.debtratio;
	year=2010;
	keep symbol year debt_ratio_10;
	rename debt_ratio_10=debtratio;
run;

data debtratio_11;
	set mydata.debtratio;
	year=2011;
	keep symbol year debt_ratio_11;
	rename debt_ratio_11=debtratio;
run;

data debtratio_12;
	set mydata.debtratio;
	year=2012;
	keep symbol year debt_ratio_12;
	rename debt_ratio_12=debtratio;
run;

data debtratio_13;
	set mydata.debtratio;
	year=2013;
	keep symbol year debt_ratio_13;
	rename debt_ratio_13=debtratio;
run;

data debtratio;
	set debtratio_08 debtratio_09 debtratio_10 debtratio_11 debtratio_12 debtratio_13;
run;

data debtratio;
	retain year symbol debtratio;
	set debtratio;
run;

proc sort data=debtratio;
	by year symbol;
run;

/**	percentage of institutional holding.	
	Need to remove NAs and replace ',' with '.' in the .csv file.	
	 ???????????????????????????????????????????
	Why are there four percentages of institutional holding variables?
	Do we also need lagged percentages of institutional holding variables (in the last year)?	*/
data mydata.institutional;
	%let _EFIERR_ = 0; /* set the ERROR detection macro variable */
	infile 'D:\research\Collaboration with Wolfgang Haerdle\20141113 SP500 Datastream Data\Sector_InstHolding_static.csv' delimiter = ';' MISSOVER DSD lrecl=32767 firstobs=2 ;
	informat name $28. ;
	informat Primary_SIC_Code best32. ;
	informat Stock_Ownership best32. ;
	informat year best32. ;
	informat Common_Shareholders best32. ;
	informat Stock_Exchange_for_Company best32. ;
	informat Company_Short_me $11. ;
	informat Issue_ID best32. ;
	informat Company_Stock_Exchange $23. ;
	informat VAR10 best32. ;
	informat Primary_SIC__Descrptn_ $28. ;
	informat Economic_Sector_Code best32. ;
	informat Economic_Sector__Descptn_ $22. ;
	informat Industry_Sector_Code best32. ;
	informat Industry_Sector__Descrptn_ $44. ;
	informat GICS_Economic_Sector best32. ;
	informat GICS_Econ_Sect__Descr_ $22. ;
	informat GICS_Industry_Group best32. ;
	informat GICS_Ind_Group__Descr_ $46. ;
	informat GICS_Industry best32. ;
	informat GICS_Industry__Descr_ $50. ;
	informat	GICS_Sub_Industry	best32.	;
	informat	GICS_Sub_industry__Descr_	$44.00 	;
	informat	ICS_Classifications	best32.	;
	informat	ICS_Classification__Descr_	$64.00 	;
	informat	Ticker__Issue_level_	$8.00 	;
	informat	symbol	$20. 	;
	informat	InstShrs_0	best32.	;
	informat	InstShrs_1	best32.	;
	informat	InstShrs_2	best32.	;
	informat	InstShrs_3	best32.	;
	format	name	$28.00 	;
	format	Primary_SIC_Code	best12.	;
	format	Stock_Ownership	best12.	;
	format	year	best12.	;
	format	Common_Shareholders	best12.	;
	format	Stock_Exchange_for_Company	best12.	;
	format	Company_Short_me	$11.00 	;
	format	Issue_ID	best12.	;
	format	Company_Stock_Exchange	$23.00 	;
	format	VAR10	best12.	;
	format	Primary_SIC__Descrptn_	$28.00 	;
	format	Economic_Sector_Code	best12.	;
	format	Economic_Sector__Descptn_	$22.00 	;
	format	Industry_Sector_Code	best12.	;
	format	Industry_Sector__Descrptn_	$44.00 	;
	format	GICS_Economic_Sector	best12.	;
	format	GICS_Econ_Sect__Descr_	$22.00 	;
	format	GICS_Industry_Group	best12.	;
	format	GICS_Ind_Group__Descr_	$46.00 	;
	format	GICS_Industry	best12.	;
	format	GICS_Industry__Descr_	$50.00 	;
	format	GICS_Sub_Industry	best12.	;
	format	GICS_Sub_industry__Descr_	$44.00 	;
	format	ICS_Classifications	best12.	;
	format	ICS_Classification__Descr_	$64.00 	;
	format	Ticker__Issue_level_	$8.00 	;
	format	symbol	$20.;
	format	InstShrs_0	best32.	;
	format	InstShrs_1	best32.	;
	format	InstShrs_2	best32.	;
	format	InstShrs_3	best32.	;

	input
name	$
Primary_SIC_Code	
Stock_Ownership	
year	
Common_Shareholders	
Stock_Exchange_for_Company	
Company_Short_me	$
Issue_ID	
Company_Stock_Exchange	$
VAR10	
Primary_SIC__Descrptn_	$
Economic_Sector_Code	
Economic_Sector__Descptn_	$
Industry_Sector_Code	
Industry_Sector__Descrptn_	$
GICS_Economic_Sector	
GICS_Econ_Sect__Descr_	$
GICS_Industry_Group	
GICS_Ind_Group__Descr_	$
GICS_Industry	
GICS_Industry__Descr_	$
GICS_Sub_Industry	
GICS_Sub_industry__Descr_	$
ICS_Classifications	
ICS_Classification__Descr_	$
Ticker__Issue_level_	$
symbol	$
InstShrs_0	
InstShrs_1	
InstShrs_2	
InstShrs_3	;
if _ERROR_ then call symputx('_EFIERR_',1);  /* set ERROR detection macro variable */
year=2000+year;
symbol=lowcase(symbol);
keep year symbol InstShrs_0 InstShrs_1	InstShrs_2	InstShrs_3	;
run;


/*	S&P 500	
	Need to replace ',' with '.' in the .csv file.	*/
/*	?????????????????????????????????????????????????????
	How to calculate log_returns?	*/
data sp500_orig    ;
	%let _EFIERR_ = 0; /* set the ERROR detection macro variable */
	infile 'D:\research\Collaboration with Wolfgang Haerdle\20141113 SP500 Datastream Data\SP500.csv' delimiter= ';' MISSOVER DSD lrecl=32767 firstobs=2 ;
	informat date yymmdd10. ;
	informat SPCOMP best32. ;
	format date yymmdd10. ;
	format SPCOMP best32. ;
	input	date SPCOMP;
	if _ERROR_ then call symputx('_EFIERR_',1);  /* set ERROR detection macro variable */
	index=_n_;
run;
data sp500_lag;
	set sp500_orig;
	if index<1804;
run;
data sp500_lag;
	set sp500_lag;
	index=index+1;
run;
data sp500_orig;
	set sp500_orig;
	if index>1;
run;
data mydata.sp500_log_returns;
	merge sp500_orig sp500_lag (drop=date rename=(SPCOMP=SPCOMP_lag));
	by index;
	sp500_log_returns=log(SPCOMP/SPCOMP_lag)*100;
run;



/*	VIX	
	Need to replace ',' with '.' in the .csv file.	*/
/*	?????????????????????????????????????????????????????
	How to calculate relevant quantities from this data set?	*/
data mydata.vix    ;
	%let _EFIERR_ = 0; /* set the ERROR detection macro variable */
	infile 'D:\research\Collaboration with Wolfgang Haerdle\20141113 SP500 Datastream Data\VIX.csv' delimiter= ';' MISSOVER DSD lrecl=32767 firstobs=2 ;
	informat date yymmdd10. ;
	informat vix_open best32. ;
	informat vix_high best32. ;
	informat vix_low best32. ;
	informat vix_close best32. ;
	format date yymmdd10. ;
	format vix_open best32. ;
	format vix_high best32. ;
	format vix_low best32. ;
	format vix_close best32. ;
	input	date vix_open vix_high vix_low vix_close;
	if _ERROR_ then call symputx('_EFIERR_',1);  /* set ERROR detection macro variable */
	keep date vix_close;
run;


/*	?????????????????????????????????????
	No credit ratings data.	*/


/*	The control variables.	*/
data controlvars;
	set output.alldepvars;
	keep date symbol;
run;

/***	sector	***/
proc sort data=controlvars;
	by symbol;
run;

proc sort data=mydata.sector;
	by symbol;
run;

data controlvars;
	merge controlvars (in=data1) mydata.sector;
	by symbol;
	if data1;
run;

/***	debt ratio	***/
/*data controlvars;
	set controlvars;
	year=year(date)-1;
run;

proc sort data=controlvars;
	by year symbol;
run;

proc sort data=mydata.debtratio;
	by year symbol;
run;

proc sql noprint;
	create table temp1 as
	select a.*, b.debtratio 
	from controlvars a, mydata.debtratio b
	where a.year=b.year and a.symbol=b.symbol;
quit;

proc sql noprint;
	create table temp2 as 
	select * from controlvars
	where cats(date,symbol) not in (select cats(date,symbol) from temp1);
quit;
data temp2;
	set temp2;
	debtratio=.;
run;
data debtratio_new;
	set temp temp2;
run;
proc sort data=debtratio_new;
	by year symbol;
run;
data controlvars;
	merge controlvars  (in=data1) debtratio;
	by year symbol;
	if data1;
run;*/

/***	percentage of institutional holding	***/
/*proc sort data=institutional;
	by year symbol;
run;

data controlvars;
	merge controlvars  (in=data1) institutional;
	by year symbol;
	if data1;
run;*/

/***	sp500	***/

/*****	Get trading dates (with nonmissing volume).	*****/
data tradingdates;
	set mydata.volume;
	if X902172 ne .;
	keep date;
run;
proc sort data=tradingdates;
	by date;
run;
data tradingdates;
	set tradingdates;
	index=_n_;
run;


proc sort data=mydata.sp500_log_returns;
	by date;
run;
data sp500;
	merge mydata.sp500_log_returns tradingdates;
	by date;
	if index ne .;
run;


data sp500_lag;
	set sp500;
	index=index-1;
	if index>0;
	keep date index;
run;
proc sort data=sp500_lag;
	by index;
run;
data sp500_lag;
	merge sp500_lag (in=data1) tradingdates (rename=(date=lagdate));
	by index;
	if data1;
run;


proc sort data=sp500_lag;
	by lagdate;
run;
data sp500;
	set sp500;
	rename date=lagdate;
run;
proc sort data=sp500;
	by lagdate;
run;
data sp500_lag;
	merge sp500_lag (in=data1) sp500;
	by lagdate;
	if data1;
run;


data sp500_lag;
	set sp500_lag;
	keep date sp500_log_returns;
	if sp500_log_returns ne .;
	rename sp500_log_returns=sp500_log_returns_tl1;
run;


proc sort data=controlvars;
	by date;
run;
proc sort data=sp500_lag;
	by date;
run;
data controlvars;
	merge controlvars (in=data1) sp500_lag;
	by date;
	if data1;
run;


/***	vix	***/
proc sort data=mydata.vix;
	by date;
run;
proc sort data=tradingdates;
	by date;
run;
data vix;
	merge mydata.vix tradingdates;
	by date;
	if index ne .;
run;


data vix_lag;
	set vix;
	index=index-1;
	if index>0;
	keep date index;
run;
proc sort data=vix_lag;
	by index;
run;
data vix_lag;
	merge vix_lag (in=data1) tradingdates (rename=(date=lagdate));
	by index;
	if data1;
run;


proc sort data=vix_lag;
	by lagdate;
run;
data vix;
	set vix;
	rename date=lagdate;
run;
proc sort data=vix;
	by lagdate;
run;
data vix_lag;
	merge vix_lag (in=data1) vix;
	by lagdate;
	if data1;
run;


data vix_lag;
	set vix_lag;
	keep date vix_close;
	if vix_close ne .;
	rename vix_close=vix_close_tl1;
run;


proc sort data=controlvars;
	by date;
run;
proc sort data=vix_lag;
	by date;
run;
data controlvars;
	merge controlvars (in=data1) vix_lag;
	by date;
	if data1;
run;



/* The final data set for control variables.	*/
data output.controlvars;
	set controlvars;
run;

