%let negdis=5;
%let lag=1;

/*	The first day in output.Sentscore_nd&negdis._tl&lag. is 2009-10-21 and the last day in output.Sentscore_nd&negdis._tl&lag. is 2014-10-14.	*/
data alldepvars;
	length symbolnew $20.;
	set output.alldepvars;
	if date>=mdy(10,21,2009) and date<=mdy(10,14,2014); /* lag=1 */
	*if date>=mdy(10,22,2009) and date<=mdy(10,14,2014); /* lag=2 */
	*if date>=mdy(10,23,2009) and date<=mdy(10,14,2014); /* lag=3 */
	*if date>=mdy(10,26,2009) and date<=mdy(10,14,2014); /* lag=4 */
	*if date>=mdy(10,27,2009) and date<=mdy(10,14,2014); /* lag=5	*/
	symbolnew=symbol;
	drop symbol;
	rename symbolnew=symbol;
run;
proc sort data=alldepvars;
	by date symbol;
run;
data sentscore_nd&negdis._tl&lag.;
	length symbolnew $20.;
	set output.Sentscore_nd&negdis._tl&lag.;
	symbolnew=symbol;
	drop symbol;
	keep date symbolnew BL_neg_prop BL_agreeindex MPQA_neg_prop MPQA_agreeindex MPQA_strongneg_prop MPQA_strongagreeindex LM_neg_prop LM_agreeindex
		BL_pos_prop MPQA_pos_prop MPQA_strongpos_prop LM_pos_prop;
	rename symbolnew=symbol;
run;
proc sort data=sentscore_nd&negdis._tl&lag.;
	by date symbol;
run;
data alldepvars_alllags;
	length symbolnew $20.;
	set output.alldepvars_alllags;
	if date>=mdy(10,21,2009) and date<=mdy(10,14,2014); /* lag=1 */
	*if date>=mdy(10,22,2009) and date<=mdy(10,14,2014); /* lag=2 */
	*if date>=mdy(10,23,2009) and date<=mdy(10,14,2014); /* lag=3 */
	*if date>=mdy(10,26,2009) and date<=mdy(10,14,2014); /* lag=4 */
	*if date>=mdy(10,27,2009) and date<=mdy(10,14,2014); /* lag=5	*/
	symbolnew=symbol;
	drop symbol;
	rename symbolnew=symbol;
run;
proc sort data=alldepvars_alllags;
	by date symbol;
run;

data output.finaldata_nd&negdis._tl&lag.;
	merge alldepvars sentscore_nd&negdis._tl&lag. alldepvars_alllags;
	by date symbol;
	if volume ne .;
	indicnews=1;
	if BL_neg_prop=. then do;
		indicnews=0;
		BL_neg_prop=0;
		BL_agreeindex=0;
		MPQA_neg_prop=0;
		MPQA_agreeindex=0;
		MPQA_strongneg_prop=0;
		MPQA_strongagreeindex=0;
		LM_neg_prop=0;
		LM_agreeindex=0;
		BL_pos_prop=0;
		MPQA_pos_prop=0;
		MPQA_strongpos_prop=0;
		LM_pos_prop=0;
	end;

%macro VarOrder();

	%let datanames=high low open price h_gk log_returns volume log_volume log_volume_linear_trend log_volume_linear_residual log_volume_expected log_volume_unexpected;
	%let lagdatanames=;

	%let ilag=1;
	%do %until (&ilag.>&lag.);

		%let idata=1;
		%do %until (%scan(&datanames.,&idata.,' ')=);

			%let dataname=%scan(&datanames.,&idata.,' ');
			%let lagdatanames=&lagdatanames. &dataname._tl&ilag.;

			%let idata=%eval(&idata.+1);
		%end;

		%let ilag=%eval(&ilag.+1);
	%end;

	data output.finaldata_nd&negdis._tl&lag.;
		retain date symbol indicnews BL_neg_prop BL_agreeindex MPQA_neg_prop MPQA_agreeindex MPQA_strongneg_prop MPQA_strongagreeindex LM_neg_prop LM_agreeindex
			&datanames. &lagdatanames. BL_pos_prop MPQA_pos_prop MPQA_strongpos_prop LM_pos_prop;
		set output.finaldata_nd&negdis._tl&lag.;
	run;
%mend;

%VarOrder();

				
