# coding: utf-8

# the path for the articles
filepath='D:/research/Collaboration with Wolfgang Haerdle/20141014_NASDAQ'

# the path for the output
outpath='D:/research/Collaboration with Wolfgang Haerdle/output'

# get the list of authors of the NASDAQ articles, equivalent to the list of subdirectories under 'filepath'
from os import walk
authors=walk('%s' %filepath).next()[1]
#print authors

# record the relationship between symbols and (author,linkfile,link) into a list
symbol_article_relations=[]
# the set of stock symbols mentioned in the articles
symbols=set([])
# the set of articles that are related to stock symbols
articles=set([])

# for each author, extract the right contents to fill into 'symbol_article_relations', 'symbols' and 'articles'
for iauthor in range(0,len(authors)):
    # these two authors do not have csv file for 'symbol'
    if authors[iauthor]!='minyanville' and authors[iauthor]!='mt-newswires':
        # open the file that records the relationship between symbols and links for this author
        relationfile=open('%s/%s/symbols_%s.csv' %(filepath,authors[iauthor],authors[iauthor]))
        # read the contents in "relationfile" and store the relevant elements into 
        # "symbol_article_relations", # "symbols" and "articles" 
        for  line in relationfile.readlines(): 
            if line.find('NO SYMBOL')==-1:
                # read symbol
                tempindex1=line.index('"',1)
                symbol=line[1:tempindex1]
                # read linkfile
                tempindex2=line.index('"',tempindex1+3)
                linkfile=line[tempindex1+3:tempindex2]
                # read link
                tempindex3=line.index('"',tempindex2+3)
                link=line[tempindex2+3:tempindex3]
                #print symbol
                #print linkfile
                #print link
                # if the symbol refers to a stock symbol, append the relation to "symbols"
                if symbol!='symbol' and symbol.find(':')==-1 and symbol.find('_')==-1 and symbol.find(',')==-1 and symbol.find('.')==-1:
                    symbol_article_relations.append([symbol,authors[iauthor],linkfile,link])
                    symbols.add(symbol)
                    articles.add('author_%s_end_%s_%s' %(authors[iauthor],linkfile,link))
#print symbol_article_relations
#print symbols
#print articles

# the file that stores the relationship between symbols and (author,linkfile,link)
frelations = open('%s/symbol_article_relations.txt' %outpath,'w')
for relations in symbol_article_relations:
    for item in relations:
        frelations.write(item)
        frelations.write('\t')
    frelations.write('\n')
frelations.close()

# the file that stores the unique symbols
fsymbols = open('%s/symbols.txt' %outpath,'w')
for symbol in symbols:
    fsymbols.write(symbol)
    fsymbols.write('\n')
fsymbols.close()

import re

# the file that stores the unique articles that mention symbols
farticles = open('%s/articles.txt' %outpath,'w')
for article in articles:
    tempindex1=article.index('_')
    tempindex2=article.index('_end',tempindex1+1)
    tempindex3=article.index('_',tempindex2+1)
    tempindex4=article.index('_',tempindex3+1)
    author=article[tempindex1+1:tempindex2]
    linkfile=article[tempindex3+1:tempindex4]
    link=article[tempindex4+1:len(article)]
    #print tempindex1
    #print tempindex2
    #print tempindex3
    #print tempindex4
    #print author
    #print linkfile
    #print link
    farticles.write(author)
    farticles.write('\t')
    farticles.write(linkfile)
    farticles.write('\t')
    farticles.write(link)
    farticles.write('\n')
farticles.close()


# record (author,linkfile,link) and the corresponding date into a list, 
# regardless of whether the articles contain symbols or not
allarticles_date=[]

# for each author, extract the right contents to fill into 'allarticles_date'
for iauthor in range(0,len(authors)):
    #print authors[iauthor]
    if authors[iauthor]!='minyanville' and authors[iauthor]!='mt-newswires':
        # open the file that records the articles and the date for this author
        datefile=open('%s/%s/metadata_%s.csv' %(filepath,authors[iauthor],authors[iauthor]))
        # read the contents in "relationfile" and store the relevant elements into 
        # "symbol_article_relations", # "symbols" and "articles" 
        for  line in datefile.readlines(): 
            #print line
            temp=line.split(';')
            #print temp
            # read date, the first part
            date=temp[0]
            if date[0]=='"':
                date=date[1:len(date)-1]
            #print date
            # read linkfile, the second to last part
            linkfile=temp[len(temp)-2]
            if linkfile[0]=='"':
                linkfile=linkfile[1:len(linkfile)-1]
            #print linkfile
            # read link, the last part
            link=temp[len(temp)-1]
            if link[0]=='"':
                link=link[1:len(link)-2]
            else:
                link=link[0:len(link)-1]
            #print link
            #print date
            #print linkfile
            #print link
            # if the date refers to a date, append the relevant record to "allarticles_date"
            if date!='date':
                allarticles_date.append([authors[iauthor],linkfile,link,date])
#print allarticles_date  

# the file that stores the dates for all articles (author,linkfile,link)
fdates = open('%s/allarticles_date.txt' %outpath,'w')
for date in allarticles_date:
    for item in date:
        fdates.write(item)
        fdates.write('\t')
    fdates.write('\n')
fdates.close()
  