#coding=utf-8
'''
sentiment analysis with lexicon from BingLiu and MPQA

'''
import nltk, re
from nltk.stem.porter import PorterStemmer
porter_stemmer = PorterStemmer()
#import sys
#reload(sys)
#sys.setdefaultencoding('utf-8')

# the path for the sentiment lexicon (Bing Liu)
lexiconpathBL='D:/research/Collaboration with Wolfgang Haerdle/Lexicon/BingLiu'
# the path for the sentiment lexicon (MPQA)
lexiconpathMPQA='D:/research/Collaboration with Wolfgang Haerdle/Lexicon/MPQA'
# the path for the output
outpath='D:/research/Collaboration with Wolfgang Haerdle/output'
# the path for the articles
filepath='D:/research/Collaboration with Wolfgang Haerdle/20141014_NASDAQ'

# Negation Words, see "Accounting for Negation in Sentiment Analysis" 
# by Bas Heerschop, Paul van Iterson and Alexander Hogenboom
NEGWORDS=['not','never','no','neither','nor','none','n\'t']
# distance between a negation word and the focus word for the polarity to be reversed
# See "Mining and Summarizing Customer Reviews" by Minqing Hu and Bing Liu.
NEGDIS=5

#read external lexicon (Bing Liu)
SenseDictBL=dict()
CategoryBL=['positive','negative']
for cat in CategoryBL:
    TempDict=dict()
    flexicon=open('%s/%s.txt' %(lexiconpathBL,cat),'rb')
    for line in flexicon:
        word=line.strip()
        if (TempDict.get(word)!=None): 
            print '%s already exists in the lexicon' %(word)
        TempDict[word]=1
    flexicon.close()
    SenseDictBL[cat]=TempDict

#read external lexicon (MPQA)
SenseDictMPQA=dict(); NumSentWordsMPQA=dict()
CategoryMPQA=[('weaksubj', 'positive'),('strongsubj', 'positive'),
              ('weaksubj', 'neutral'),('strongsubj', 'neutral'),
              ('weaksubj', 'negative'),('strongsubj', 'negative'),
              ('weaksubj', 'both'),('strongsubj', 'both')]
flexicon=open('%s/subjclueslen1-HLTEMNLP05.tff' %(lexiconpathMPQA),'rb')
for line in flexicon:
    text=line.strip() #remove the newline character at the end of the input line.
    if (len(text)==0): continue
    text=text.split(' '); word=list(); sense=list()
    for i in range(len(text)):
        if(i==0): pair=text[i]; pair=pair.split('='); sense.append(pair[1])
        if(i==len(text)-1): pair=text[i]; pair=pair.split('='); sense.append(pair[1])
        if(i>1 and i<len(text)-1): pair=text[i]; pair=pair.split('='); word.append(pair[1])
    wordpos=tuple(word)
    SenseDictMPQA[wordpos]=tuple(sense); NumSentWordsMPQA.setdefault(tuple(sense),0)
flexicon.close()

# The mapping from ntlk POS tags to MPQA POS tags.
PosTrans={'JJ':'adj','NN':'noun','VB':'verb','RB':'adverb'}
# The MPQA POS tags.
StanPos=['adj','noun','verb','adverb']

# for every relevant article
farticledate = open('%s/articles_date.txt' %outpath,"rb")
farticlesentiment_BL_neg = open('%s/articles_sentiment_BL_negdis%s.txt' %(outpath,NEGDIS),"w")
farticlesentiment_MPQA_neg = open('%s/articles_sentiment_MPQA_negdis%s.txt' %(outpath,NEGDIS),"w")
for line in farticledate.readlines():
#if 1:
#    line=farticledate.readline()    
    text=line.strip() #remove the newline character at the end of the input line.
    if (len(text)==0): continue
    temp=line.split('\t')
    order=temp[0]
    author=temp[1]
    linkfile=temp[2]
    link=temp[3]
    date=temp[4]
    flag=temp[5]
    flag=flag[0:len(flag)-1]
    #print author
    #print linkfile
    #print link
    #print flag
    if (flag.find('1')!=-1):
        #WordDictBL=dict()
        #WordDictMPQA=dict() 
        #NumWords: The total number of words in the current article. 
        NumWords=0        
        #NumSentWordsBL: The counts of BL sentiment words in the current article.
        NumSentWordsBL=dict()
        #NumSentWordsMPQA: The counts of MPQA sentiment words in the current article.
        NumSentWordsMPQA=dict()
        #print NumSentWordsMPQA
        # Read the current file.
        f=open('%s/%s/articles_proc/%s-%s_article_proc.txt' %(filepath,author,linkfile,link),"r")
        for line in f:
            #print line
            tline=line.decode('utf-8','replace')
            #print tline.find(u'\ufffd')
            #print tline
            while (tline.find(u'\ufffd')!=-1):
                pos=tline.find(u'\ufffd')
                tline=tline[0:pos]+' '+tline[pos+1:]
                #print tline[pos]
            #print tline
            text=tline.strip() #remove the newline character at the end of the input line.
            if (len(text)==0): continue
            sentence=nltk.sent_tokenize(text)
            #print sentence  
            words=list()
            for sen in sentence:
                words.append(nltk.word_tokenize(sen.lower()))
            #print words
            for token in words:
                #print token
                
                # Find the positions of negation words in the current sentence.
                posnegwords=[]
                for itoken in range(len(token)):
                    if (token[itoken]=='not' or token[itoken]=='never' 
                        or token[itoken]=='no' or token[itoken]=='neither' 
                        or token[itoken]=='nor' or token[itoken]=='none'
                        or token[itoken]=='n\'t'):
                        posnegwords.append(itoken)
                #print posnegwords
                        
                postags=nltk.pos_tag(token)
                #print pairwise
                for ipostag in range(len(postags)):
                    postag=postags[ipostag]   
                    word=postag[0]; 
                    #delete token which only contain punctuations
                    if re.search(r'\w',word):
                        #WordDictBL.setdefault(word,0); 
                        #WordDictBL[word]+=1
                        NumWords+=1 
                               
                        # Indicating whether the polarity of the current word needs to be reversed.
                        negflag=0
                        for iposnegword in range(len(posnegwords)):
                            if abs(ipostag-iposnegword)<=NEGDIS:
                                negflag=1
                        #print negflag

                        for cat in CategoryBL:
                            if (SenseDictBL[cat].get(word)==1):
                                catnew=cat
                                if (negflag==1):
                                    if cat=='positive':
                                        catnew='negative'
                                    if cat=='negative':
                                        catnew='positive'                                 
                                NumSentWordsBL[(word,catnew)]=NumSentWordsBL.get((word,catnew),0)+1
                        
                        pos=''
                        if (postag[1].find('JJ')!=-1):
                            pos='JJ'
                        if (postag[1].find('NN')!=-1):
                            pos='NN'
                        if (postag[1].find('VB')!=-1):
                            pos='VB'
                        if (postag[1].find('RB')!=-1):
                            pos='RB' 
                        if (pos==''):
                            pos=postag[1] 
                        #print postag[1]
                        #print pos 
                        # Indicating whether the sentiment of the current word has been counted.                   
                        countflag=0
                        
                        stemmer='n' #without stem for word
                        postag=PosTrans.get(pos)
                        if (postag!=None):
                            key=tuple([word,postag,stemmer])
                            if (SenseDictMPQA.get(key)): 
                                sense=SenseDictMPQA[key]
                                if (negflag==1):
                                    if sense[1]=='positive':
                                        sense=tuple([sense[0],'negative'])
                                    if sense[1]=='negative':
                                        sense=tuple([sense[0],'positive'])
                                NumSentWordsMPQA[tuple([key[0],key[1],key[2],sense[0],sense[1]])]=NumSentWordsMPQA.get(tuple([key[0],key[1],key[2],sense[0],sense[1]]),0)+1
                                countflag=1
                        if countflag==0:
                            key=tuple([word,'anypos',stemmer])
                            if (SenseDictMPQA.get(key)): 
                                sense=SenseDictMPQA[key]
                                #print sense
                                if (negflag==1):
                                    if sense[1]=='positive':
                                        sense=tuple([sense[0],'negative'])
                                    if sense[1]=='negative':
                                        sense=tuple([sense[0],'positive'])
                                NumSentWordsMPQA[tuple([key[0],key[1],key[2],sense[0],sense[1]])]=NumSentWordsMPQA.get(tuple([key[0],key[1],key[2],sense[0],sense[1]]),0)+1
                                countflag=1
                        if countflag==0:
                            stemmer='y'
                            word=porter_stemmer.stem(word)
                            if (postag!=None):
                                key=tuple([word,postag,stemmer])
                                if (SenseDictMPQA.get(key)): 
                                    sense=SenseDictMPQA[key]
                                    #print sense
                                    if (negflag==1):
                                        if sense[1]=='positive':
                                            sense=tuple([sense[0],'negative'])
                                        if sense[1]=='negative':
                                            sense=tuple([sense[0],'positive'])
                                    NumSentWordsMPQA[tuple([key[0],key[1],key[2],sense[0],sense[1]])]=NumSentWordsMPQA.get(tuple([key[0],key[1],key[2],sense[0],sense[1]]),0)+1
                                    countflag=1
                            if countflag==0:
                                key=tuple([word,'anypos',stemmer])
                                if (SenseDictMPQA.get(key)): 
                                    sense=SenseDictMPQA[key]
                                    #print sense
                                    if sense[1]=='positive':
                                        sense=tuple([sense[0],'negative'])
                                    if sense[1]=='negative':
                                        sense=tuple([sense[0],'positive'])
                                    NumSentWordsMPQA[tuple([key[0],key[1],key[2],sense[0],sense[1]])]=NumSentWordsMPQA.get(tuple([key[0],key[1],key[2],sense[0],sense[1]]),0)+1
                                    countflag=1
            #print WordDict
        f.close()
        

#       for word in WordDictBL:
#            NumWords+=WordDictBL[word]
#            for cat in CategoryBL:
#                if (SenseDictBL[cat].get(word)==1): 
#                    NumSentWordsBL[cat]+=WordDictBL[word]
        
            
#        for key in WordDictMPQA:
#            if (SenseDictMPQA.get(key)): 
#                sense=SenseDictMPQA[key]
#                NumSentWordsMPQA[sense]+=WordDictMPQA[key]
#            else:
#                pos=key[1]; new=list()
#                if(pos in StanPos): 
#                    for i in range(len(key)):
#                        new.append(key[i])
#                    new[1]='anypos'; new=tuple(new)
#                    if(SenseDictMPQA.get(new)): 
#                        sense=SenseDictMPQA[new]
#                        NumSentWordsMPQA[sense]+=WordDictMPQA[key]

        for key in NumSentWordsBL:
            farticlesentiment_BL_neg.write(order)
            farticlesentiment_BL_neg.write('\t')
            farticlesentiment_BL_neg.write(key[0])
            farticlesentiment_BL_neg.write('\t')
            farticlesentiment_BL_neg.write(key[1])
            farticlesentiment_BL_neg.write('\t')
            farticlesentiment_BL_neg.write(str(NumSentWordsBL[key]))
            farticlesentiment_BL_neg.write('\n')
        for key in NumSentWordsMPQA:
            farticlesentiment_MPQA_neg.write(order)
            farticlesentiment_MPQA_neg.write('\t')
            farticlesentiment_MPQA_neg.write(key[0])
            farticlesentiment_MPQA_neg.write('\t')
            farticlesentiment_MPQA_neg.write(key[1])
            farticlesentiment_MPQA_neg.write('\t')
            farticlesentiment_MPQA_neg.write(key[2])
            farticlesentiment_MPQA_neg.write('\t')
            farticlesentiment_MPQA_neg.write(key[3])
            farticlesentiment_MPQA_neg.write('\t')
            farticlesentiment_MPQA_neg.write(key[4])
            farticlesentiment_MPQA_neg.write('\t')
            farticlesentiment_MPQA_neg.write(str(NumSentWordsMPQA[key]))
            farticlesentiment_MPQA_neg.write('\n')

farticlesentiment_BL_neg.close()
farticlesentiment_MPQA_neg.close()
#print NumSentWordsMPQA

    
