#coding=utf-8
'''
sentiment analysis with lexicon from LM

'''
import nltk, re
from nltk.stem.porter import PorterStemmer
porter_stemmer = PorterStemmer()
#import sys
#reload(sys)
#sys.setdefaultencoding('utf-8')

# the path for the sentiment lexicon (Bing Liu)
lexiconpathBL='D:/research/Collaboration with Wolfgang Haerdle/Lexicon/LM'
# the path for the output
outpath='D:/research/Collaboration with Wolfgang Haerdle/output'
# the path for the articles
filepath='D:/research/Collaboration with Wolfgang Haerdle/20141014_NASDAQ'

# Negation Words, see "Accounting for Negation in Sentiment Analysis" 
# by Bas Heerschop, Paul van Iterson and Alexander Hogenboom
NEGWORDS=['not','never','no','neither','nor','none','n\'t']
# distance between a negation word and the focus word for the polarity to be reversed
# See "Mining and Summarizing Customer Reviews" by Minqing Hu and Bing Liu.
NEGDIS=5

#read external lexicon (Bing Liu)
SenseDictLM=dict()
CategoryLM=['Negative','Positive','Uncertainty','Litigious','ModalStrong','ModalWeak']
for cat in CategoryLM:
    TempDict=dict()
    flexicon=open('%s/LoughranMcDonald_%s.csv' %(lexiconpathBL,cat),'rb')
    for line in flexicon:
        word=line.strip()
        word=word.lower()
        #print word
        if (TempDict.get(word)!=None): 
            print '%s already exists in the lexicon' %(word)
        TempDict[word]=1
    flexicon.close()
    SenseDictLM[cat]=TempDict

# for every relevant article
farticledate = open('%s/articles_date.txt' %outpath,"rb")
farticlesentiment_neg = open('%s/articles_sentiment_negdis%s_LM.txt' %(outpath,NEGDIS),"w")
for line in farticledate.readlines():
#if 1:
#    line=farticledate.readline()    
    text=line.strip() #remove the newline character at the end of the input line.
    if (len(text)==0): continue
    temp=line.split('\t')
    order=temp[0]
    author=temp[1]
    linkfile=temp[2]
    link=temp[3]
    date=temp[4]
    flag=temp[5]
    flag=flag[0:len(flag)-1]
    #print author
    #print linkfile
    #print link
    #print flag
    if (flag.find('1')!=-1):
        #WordDictBL=dict()
        #WordDictMPQA=dict() 
        #NumWords: The total number of words in the current article. 
        NumWords=0        
        #NumSentWordsLM: The counts of LM sentiment words in the current article.
        NumSentWordsLM=dict()
        for cat in CategoryLM:
            NumSentWordsLM.setdefault(cat,0)
        # Read the current file.
        f=open('%s/%s/articles_proc/%s-%s_article_proc.txt' %(filepath,author,linkfile,link),"r")
        for line in f:
            #print line
            tline=line.decode('utf-8','replace')
            #print tline.find(u'\ufffd')
            #print tline
            while (tline.find(u'\ufffd')!=-1):
                pos=tline.find(u'\ufffd')
                tline=tline[0:pos]+' '+tline[pos+1:]
                #print tline[pos]
            #print tline
            text=tline.strip() #remove the newline character at the end of the input line.
            if (len(text)==0): continue
            sentence=nltk.sent_tokenize(text)
            #print sentence  
            words=list()
            for sen in sentence:
                words.append(nltk.word_tokenize(sen.lower()))
            #print words
            for token in words:
                #print token
                
                # Find the positions of negation words in the current sentence.
                posnegwords=[]
                for itoken in range(len(token)):
                    if (token[itoken]=='not' or token[itoken]=='never' 
                        or token[itoken]=='no' or token[itoken]=='neither' 
                        or token[itoken]=='nor' or token[itoken]=='none'
                        or token[itoken]=='n\'t'):
                        posnegwords.append(itoken)
                #print posnegwords
                        
                #print pairwise
                for itoken in range(len(token)):
                    word=token[itoken];
                    #print word; 
                    #delete token which only contain punctuations
                    if re.search(r'\w',word):
                        #WordDictBL.setdefault(word,0); 
                        #WordDictBL[word]+=1
                        NumWords+=1 
                               
                        # Indicating whether the polarity of the current word needs to be reversed.
                        negflag=0
                        for iposnegword in range(len(posnegwords)):
                            if abs(itoken-iposnegword)<=NEGDIS:
                                negflag=1
                        #print negflag

                        for cat in CategoryLM:
                            if (SenseDictLM[cat].get(word)==1):
                                catnew=cat
                                if (negflag==1):
                                    if cat=='Positive':
                                        catnew='Negative'
                                    if cat=='Negative':
                                        catnew='Positive'                                 
                                NumSentWordsLM[catnew]+=1
                        
            #print WordDict
        f.close()
        


        farticlesentiment_neg.write(order)
        farticlesentiment_neg.write('\t')
        farticlesentiment_neg.write(str(NumWords))
        farticlesentiment_neg.write('\t')
        farticlesentiment_neg.write(str(NumSentWordsLM['Negative']))
        farticlesentiment_neg.write('\t')
        farticlesentiment_neg.write(str(NumSentWordsLM['Positive']))
        farticlesentiment_neg.write('\t')
        farticlesentiment_neg.write(str(NumSentWordsLM['Uncertainty']))
        farticlesentiment_neg.write('\t')
        farticlesentiment_neg.write(str(NumSentWordsLM['Litigious']))
        farticlesentiment_neg.write('\t')
        farticlesentiment_neg.write(str(NumSentWordsLM['ModalStrong']))
        farticlesentiment_neg.write('\t')
        farticlesentiment_neg.write(str(NumSentWordsLM['ModalWeak']))
        farticlesentiment_neg.write('\n')

farticlesentiment_neg.close()
#print NumSentWordsMPQA

    
