setwd("")
library(locfit)
library(KernSmooth)
sim.df = read.csv2("AttentionSimulation")
sim.df = sim.df[1:9]
par(mfrow=c(1,1))
pdf(paste("fig_entire_panel_scat", ".pdf", sep=""),width = 6.4, height = 3.6)
par(mar=c(3.0,3.1,1,1.7))
par(mfrow=c(2,3))

x    = sim.df$BL_Neg_Proportion
y    = sim.df$BL_SimulatedVolatility

bw   = dpill(x, y,) # Select Binwidth automatically

plot(sim.df$BL_Neg_Proportion,
     sim.df$BL_SimulatedVolatility,
     pch = 20, cex = 0.5, col="#00000010",
     ylab = "BL Simulated Volatility",
     xlab = paste("BL Negative Proportion, h = ", round(bw, 4), sep=""),
     cex.axis = 0.9, tck= -0.03, mgp=c(1.5,0.3,0), cex.lab = 1)


llr   = locfit(y~lp(x,h = bw,deg=1), kern ="gauss", deg = 1)
bands = scb(y~lp(x, h = bw, deg=1), type = 1, ev = lfgrid(100), simul = TRUE,
            kern = "gauss", deg = 1)

lines(llr, col = "blue", lwd = 2)
lines(bands$x, bands$lower, col="red", lwd=2, lty = "dashed")
lines(bands$x, bands$upper, col="red", lwd=2, lty = "dashed")


# LM Negative Proportion
x    = sim.df$LM_Neg_Proportion
y    = sim.df$LM_SimulatedVolatility
bw = dpill(x, y,)

plot(sim.df$LM_Neg_Proportion,
     sim.df$LM_SimulatedVolatility,
     pch = 20, cex = 0.5, col="#00000010",
     ylab = "LM Simulated Volatility",
     xlab = paste("LM Negative Proportion, h = ", round(bw, 4), sep=""),
     cex.axis = 0.9, tck= -0.03, mgp=c(1.5,0.3,0), cex.lab = 1)

llr   = locfit(y~lp(x,h = bw,deg=1), kern ="gauss", deg = 1)
bands = scb(y~lp(x, h = bw,deg=1), type = 1, ev = lfgrid(100), simul = TRUE,
            kern = "gauss", deg = 1)

lines(llr, col = "blue", lwd = 2)
lines(bands$x, bands$lower, col="red", lwd=2, lty = "dashed")
lines(bands$x, bands$upper, col="red", lwd=2, lty = "dashed")

# MPQA Negative Proportion
x    = sim.df$MPQA_Neg_Proportion
y    = sim.df$MPQA_SimulatedVolatility
bw = dpill(x, y,)

plot(sim.df$MPQA_Neg_Proportion,
     sim.df$MPQA_SimulatedVolatility,
     pch = 20, cex = 0.5, col="#00000010",
     ylab = "MPQA Simulated Volatility",
     xlab = paste("MPQA Negative Proportion, h = ", round(bw, 4), sep=""),
     cex.axis = 0.9, tck= -0.03, mgp=c(1.5,0.3,0), cex.lab = 1)

llr   = locfit(y~lp(x,h = bw,deg=1), kern ="gauss", deg = 1)
bands = scb(y~lp(x, h = bw,deg=1), type = 1, ev = lfgrid(100), simul = TRUE,
            kern = "gauss", deg = 1)

lines(llr, col = "blue", lwd = 2)
lines(bands$x, bands$lower, col="red", lwd=2, lty = "dashed")
lines(bands$x, bands$upper, col="red", lwd=2, lty = "dashed")


# BL Positive Proportion
x    = sim.df$BL_Pos_Proportion
y    = sim.df$BL_SimulatedVolatility
bw   = dpill(x, y,)

plot(sim.df$BL_Pos_Proportion,
     sim.df$BL_SimulatedVolatility,
     pch = 20, cex = 0.5, col="#00000010",
     ylab = "BL Simulated Volatility",
     xlab = paste("BL Positive Proportion, h = ", round(bw, 4), sep=""),
     cex.axis = 0.9, tck= -0.03, mgp=c(1.5,0.3,0), cex.lab = 1)

llr   = locfit(y~lp(x,h = bw,deg=1), kern ="gauss", deg = 1)
bands = scb(y~lp(x, h = bw, deg=1), type = 1, ev = lfgrid(100), simul = TRUE,
            kern = "gauss", deg = 1)

lines(llr, col = "blue", lwd = 2)
lines(bands$x, bands$lower, col="red", lwd=2, lty = "dashed")
lines(bands$x, bands$upper, col="red", lwd=2, lty = "dashed")

# LM Pos Proportion
x    = sim.df$LM_Pos_Proportion
y    = sim.df$LM_SimulatedVolatility
bw   = dpill(x, y,)

plot(sim.df$LM_Pos_Proportion,
     sim.df$LM_SimulatedVolatility,
     pch = 20, cex = 0.5, col="#00000010",
     ylab = "LM Simulated Volatility",
     xlab = paste("LM Positive Proportion, h = ", round(bw, 4), sep=""),
     cex.axis = 0.9, tck= -0.03, mgp=c(1.5,0.3,0), cex.lab = 1)


llr   = locfit(y~lp(x,h = bw,deg=1), kern ="gauss", deg = 1)
bands = scb(y~lp(x, h = bw,deg=1), type = 1, ev = lfgrid(100), simul = TRUE, kern = "gauss", deg = 1)

lines(llr, col = "blue", lwd = 2)
lines(bands$x, bands$lower, col="red", lwd=2, lty = "dashed")
lines(bands$x, bands$upper, col="red", lwd=2, lty = "dashed")

# MPQA Positive Proportion
x    = sim.df$MPQA_Pos_Proportion
y    = sim.df$MPQA_SimulatedVolatility
bw   = dpill(x, y,)

plot(sim.df$MPQA_Pos_Proportion,
     sim.df$MPQA_SimulatedVolatility,
     pch = 20, cex = 0.5, col="#00000010",
     ylab = "MPQA Simulated Volatility",
     xlab = paste("MPQA Positive Proportion, h = ", round(bw, 4), sep=""),
     cex.axis = 0.9, tck= -0.03, mgp=c(1.5,0.3,0), cex.lab = 1)


llr   = locfit(y~lp(x,h = bw,deg=1), kern ="gauss", deg = 1)
bands = scb(y~lp(x, h = bw,deg=1), type = 1, ev = lfgrid(100), simul = TRUE, kern = "gauss", deg = 1)

lines(llr, col = "blue", lwd = 2)
lines(bands$x, bands$lower, col="red", lwd=2, lty = "dashed")
lines(bands$x, bands$upper, col="red", lwd=2, lty = "dashed")

dev.off()

